﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Navigation;
using Infragistics;

namespace TGF.P2R.Views
{
    public partial class TestPage : Page
    {
        public TestPage()
        {
            InitializeComponent();
            this.xamGridPR.CellExitedEditMode += new EventHandler<Infragistics.Controls.Grids.CellExitedEditingEventArgs>(igGrid_CellExitedEditMode);
            this.xamGridPR.Columns.DataColumns["ColTotal"].SummaryColumnSettings.SummaryOperands.Add(new StandardDeviationOperand());


        }

        // Executes when the user navigates to this page.
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            if (App._businessContext != null)
            {
                pnlRoot.DataContext = App._businessContext.ScoreCard.PRRecommendations.PRRecommendationList[0].PRStep6;
                xamGridPR.ItemsSource = App._businessContext.ScoreCard.PRRecommendations.PRRecommendationList[0].PRStep6.CashAtCutoffDateList.ToList();

            }


        }

        void igGrid_CellExitedEditMode(object sender, Infragistics.Controls.Grids.CellExitedEditingEventArgs e)
        {
            //update the summaries after a cell has exited update mode
            this.xamGridPR.InvalidateData();



        }

        private void Page_Loaded(object sender, RoutedEventArgs e)
        {

        }


    }
}


public class StandardDeviationCalc : SynchronousSummaryCalculator
{
    public override SummaryExecution? SummaryExecution
    {
        get
        {

            return Infragistics.SummaryExecution.PriorToFilteringAndPaging;
        }
    }

    public override object Summarize(IQueryable data, string fieldKey)
    {
        IQueryable<TGF.Common.Business.TW.CashAtCutoffDateRecord> convertedData = (IQueryable<TGF.Common.Business.TW.CashAtCutoffDateRecord>)data;

        // Variables used for intermediate calculations
        double sum = 0;
        double tempVal = 0;

        foreach (TGF.Common.Business.TW.CashAtCutoffDateRecord item in convertedData)
        {
            // Value in UnitsInStock column
            tempVal = Convert.ToDouble(item.PR.Value);

            // Sum values in UnitsInStock column
            sum += tempVal;

        }
        // Return the sum
        return sum;
    }

}

public class StandardDeviationOperand : SummaryOperandBase
{
    StandardDeviationCalc myCalc;

    protected override string DefaultRowDisplayLabel
    {
        get { return "Standard Deviation"; }
    }

    protected override string DefaultSelectionDisplayLabel
    {
        get { return "Standard Deviation"; }
    }

    public override SummaryCalculatorBase SummaryCalculator
    {
        get
        {
            if (myCalc == null)
            {
                this.myCalc = new StandardDeviationCalc();
            }
            return this.myCalc;
        }
    }
}




